
USE pubs
GO

CREATE PROC dbo.getauthors
AS
SELECT * FROM authors
GO

CREATE PROC dbo.getauthors2
AS
EXEC('SELECT * FROM authors')
GO

CREATE PROC dbo.getauthors3
AS
EXEC sp_executesql N'SELECT * FROM authors'
GO

CREATE USER fred WITHOUT LOGIN
GO

GRANT EXECUTE ON dbo.getauthors TO fred
GRANT EXECUTE ON dbo.getauthors2 TO fred
GRANT EXECUTE ON dbo.getauthors3 TO fred

-- alternatively
GRANT EXECUTE ON schema::dbo TO fred
GO

EXECUTE AS USER='fred'
EXEC dbo.getauthors
EXEC dbo.getauthors2
EXEC dbo.getauthors3
REVERT

DROP USER fred

DROP PROCEDURE dbo.getauthors
DROP PROCEDURE dbo.getauthors2
DROP PROCEDURE dbo.getauthors3